Skip to main content
POST
/
projects
/
{projectIdOrName}
/
provider-apps
Create a new provider app
curl --request POST \
  --url https://api.withampersand.com/v1/projects/{projectIdOrName}/provider-apps \
  --header 'Content-Type: application/json' \
  --header 'X-Api-Key: <api-key>' \
  --data '
{
  "provider": "salesforce",
  "clientId": "client-id-123",
  "clientSecret": "client-secret-123",
  "externalRef": "external-id-123",
  "scopes": [
    [
      "read",
      "write"
    ]
  ],
  "metadata": {
    "authQueryParams": {
      "optional_scope": [
        "automation.sequences.read"
      ]
    },
    "providerParams": {
      "packageInstallURL": "https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789",
      "gcpProjectId": "my-gcp-project",
      "gcpPubSubTopicName": "my-topic"
    }
  }
}
'
import requests

url = "https://api.withampersand.com/v1/projects/{projectIdOrName}/provider-apps"

payload = {
    "provider": "salesforce",
    "clientId": "client-id-123",
    "clientSecret": "client-secret-123",
    "externalRef": "external-id-123",
    "scopes": [["read", "write"]],
    "metadata": {
        "authQueryParams": { "optional_scope": ["automation.sequences.read"] },
        "providerParams": {
            "packageInstallURL": "https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789",
            "gcpProjectId": "my-gcp-project",
            "gcpPubSubTopicName": "my-topic"
        }
    }
}
headers = {
    "X-Api-Key": "<api-key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
  method: 'POST',
  headers: {'X-Api-Key': '<api-key>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    provider: 'salesforce',
    clientId: 'client-id-123',
    clientSecret: 'client-secret-123',
    externalRef: 'external-id-123',
    scopes: [['read', 'write']],
    metadata: {
      authQueryParams: {optional_scope: ['automation.sequences.read']},
      providerParams: {
        packageInstallURL: 'https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789',
        gcpProjectId: 'my-gcp-project',
        gcpPubSubTopicName: 'my-topic'
      }
    }
  })
};

fetch('https://api.withampersand.com/v1/projects/{projectIdOrName}/provider-apps', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));


{
  "id": "provider-app-123",
  "projectId": "project-456",
  "provider": "salesforce",
  "clientId": "client-id-123",
  "createTime": "2023-11-07T05:31:56Z",
  "externalRef": "external-id-123",
  "scopes": [
    [
      "oauth",
      "offline",
      "crm.read"
    ]
  ],
  "metadata": {
    "authQueryParams": {
      "optional_scope": [
        "automation.sequences.read"
      ]
    },
    "providerParams": {
      "packageInstallURL": "https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789",
      "gcpProjectId": "my-gcp-project",
      "gcpPubSubTopicName": "my-topic"
    }
  },
  "updateTime": "2023-11-07T05:31:56Z"
}
{
  "type": "about:blank",
  "href": "https://www.belgif.be/specification/rest/api-guide/#standardized-problem-types",
  "title": "Bad Request",
  "status": 400,
  "detail": "The input message is incorrect",
  "instance": "123456-1234-1235-4567489798",
  "issues": [
    {
      "type": "about:blank",
      "detail": "exampleNumericProperty should be numeric",
      "in": "path",
      "name": "exampleNumericProperty",
      "value": "abc"
    },
    {
      "type": "about:blank",
      "title": "Input isn't valid with respect to schema",
      "detail": "examplePropertyWithPattern a2345678901 doesn't match pattern '^\\d{11}$'",
      "in": "body",
      "name": "items[0].examplePropertyWithPattern",
      "value": "a2345678901"
    }
  ]
}
{
  "type": "about:blank",
  "href": "https://www.belgif.be/specification/rest/api-guide/#standardized-problem-types",
  "title": "Bad Request",
  "status": 400,
  "detail": "The input message is incorrect",
  "instance": "123456-1234-1235-4567489798",
  "issues": [
    {
      "type": "about:blank",
      "detail": "exampleNumericProperty should be numeric",
      "in": "path",
      "name": "exampleNumericProperty",
      "value": "abc"
    },
    {
      "type": "about:blank",
      "title": "Input isn't valid with respect to schema",
      "detail": "examplePropertyWithPattern a2345678901 doesn't match pattern '^\\d{11}$'",
      "in": "body",
      "name": "items[0].examplePropertyWithPattern",
      "value": "a2345678901"
    }
  ]
}
{
  "type": "urn:problem-type:exampleOrganization:exampleProblem",
  "href": "https://www.belgif.be/specification/rest/api-guide/#standardized-problem-types",
  "title": "Description of the type of problem that occurred",
  "status": 400,
  "detail": "Description of specific occurrence of the problem",
  "instance": "urn:uuid:123e4567-e89b-12d3-a456-426614174000"
}

Authorizations

X-Api-Key
string
header
required

Path Parameters

projectIdOrName
string
required

The Ampersand project ID or project name.

Body

application/json
provider
string
required

The SaaS provider that this app connects to.

Example:

"salesforce"

clientId
string
required

The OAuth client ID for this app.

Example:

"client-id-123"

clientSecret
string
required

The OAuth client secret for this app.

Example:

"client-secret-123"

externalRef
string

The ID used by the provider to identify the app (optional).

Example:

"external-id-123"

scopes
string[]

The OAuth scopes for this app.

metadata
Provider App Metadata · object

Provider-specific configuration that extends the standard OAuth flow.

Response

The newly created provider app

id
string
required

The provider app ID.

Example:

"provider-app-123"

projectId
string
required

The Ampersand project ID.

Example:

"project-456"

provider
string
required

The SaaS provider that this app connects to.

Example:

"salesforce"

clientId
string
required

The OAuth client ID for this app.

Example:

"client-id-123"

createTime
string<date-time>
required

The time the provider app was created.

externalRef
string

The ID used by the provider to identify the app (optional).

Example:

"external-id-123"

scopes
string[]

The OAuth scopes for this app.

metadata
Provider App Metadata · object

Provider-specific configuration that extends the standard OAuth flow.

updateTime
string<date-time>

The time the provider app was updated.